<template>
  <div
    id="searchbar"
    class="d-flex"
  >
    <b-form-input
      id="searchbar-input"
      v-model="searchQuery"
      placeholder="Lookup Object by ID"
      @keyup.enter="search"
    />
    <b-button
      id="searchbar-button"
      :disabled="$v.$invalid"
      class="shadow-none"
      pill
      @click="search"
    >
      <font-awesome-icon icon="search" />
    </b-button>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { required } from 'vuelidate/lib/validators';

export default Vue.extend({
  data() {
    return {
      options: [
        { value: 'ztfObjectId', text: 'ZTF Object ID' },
        { value: 'antaresLocusId', text: 'ANTARES Locus ID' },
      ],
      searchQuery: '',
      selected: 'ztfObjectId',
    };
  },

  validations: {
    searchQuery: {
      required,
    },
  },

  methods: {
    search() {
      this.$emit('search', [
        {
          type: 'query_string',
          field: {
            query: `*${this.searchQuery}*`,
            fields: ['properties.ztf_object_id', 'locus_id'],
          },
          value: null,
          text: `ID Lookup: ${this.searchQuery}`,
        },
      ]);
      this.searchQuery = '';
    },
  },
});
</script>

<style scoped>
#searchbar {
  background-color: #414652;
  border-radius: 50px;
  padding: 0 5px;
}
#searchbar:focus-within {
  border: red;
  border-width: 4px;
}
#searchbar-button {
  background-color: rgba(0, 0, 0, 0);
  border: none;
  color: #dddddd;
}
#searchbar-input {
  background-color: rgba(0, 0, 0, 0);
  border-radius: 50x;
  border: none;
  color: #dddddd;
  font-size: 1em;
  font-weight: bold;
}
::placeholder {
  color: white;
  opacity: 1;
}
</style>
